#include "funcs.h"
#include <math.h>
extern double delta,t0;
extern int jmax,overflow;
double expo1(double x) {
  if (fabs(x)>680) {
     if (x>0) {
       overflow=1;
       return 0;
     }
     else return 0;
  }
  else return exp(x);
}

double erfdp1(double z__)
{
    double ret_val, d__1;

    static int n;
    static double const__, pi, arg, alp;

    pi = 3.14159265;
    const__ = 2. / sqrt(pi);
    arg = fabs(z__);
    ret_val = 0.;
    if (arg == 0.) {
	return ret_val;
    }

    if (arg < 2.) {
	ret_val = arg;
	alp = arg;
	for (n = 1; n <= 100; ++n) {
/* Computing 2nd power */
	    d__1 = arg;
	    alp *= -(d__1 * d__1) * ((n << 1) - 1) / ((n << 1) + 1) / n;
	    ret_val += alp;
	    if (fabs(alp) < 1e-7) {
		goto L1;
	    }
	}
L1:
	ret_val = const__ * ret_val;

    } else if (arg < 4.) {
	alp = arg;
	n = 20;
L2:
	alp = arg + n / 2. / alp;
	--n;
	if (n > 0) {
	    goto L2;
	}
	alp = 1. / alp;
/* Computing 2nd power */
	d__1 = z__;
	ret_val = 1. - const__ * exp(-(d__1 * d__1)) * alp / 2.;

    } else {
	ret_val = 1.;
    }

    if (z__ < 0.) {
	ret_val = -ret_val;
    }

    return ret_val;
}



void funcs(double x, double *a,double *ymod, double dyda[], int ma)
{
  int j,ju,jsig;
  double aerf1,aerf2,const1,sqpi,tau,const2,const3,sig,const4,exp1,exp2,erf1,erf2;
  double yji,yjip1,dyti,dytip1;
  sqpi=sqrt(3.14159265);  
  ju=2*jmax+1;
  jsig=ju+1;
  sig=a[jsig];
  aerf1=(x*delta-t0)/sig;
  aerf2=((x+1)*delta-t0)/sig;
  erf1=erfdp1(aerf1);
  erf2=erfdp1(aerf2);
  *ymod=a[ju];
  dyda[jsig]=0;
  for (j=1;j<=jmax;j++)
  {
    tau=a[jmax+j];
    const1=sig/2./tau;
    const2=(x*delta-t0)/tau;
    const3=((x+1.)*delta-t0)/tau;
    yji=expo1(-const2+pow(const1,2))*(1.-erfdp1(const1-aerf1));
    if (overflow==1) yji=0;
    yjip1=expo1(-const3+pow(const1,2))*(1.-erfdp1(const1-aerf2));
    if (overflow==1) yjip1=0;
    dyda[j]=0.5*(yji-yjip1-erf1+erf2);
    *ymod+=a[j]*dyda[j];
    const4=sig/pow(tau,2)/sqpi;
    exp1=expo1(-pow(aerf1,2));
    if (overflow==1) exp1=0;
    exp2=expo1(-pow(aerf2,2));
    if (overflow==1) exp2=0; 
    dyti=(const2-2.*pow(const1,2))*yji/tau+const4*exp1;
    dytip1=(const3-2.*pow(const1,2))*yjip1/tau+const4*exp2;
    dyda[jmax+j]=0.5*a[j]*(dyti-dytip1);
    dyda[jsig]=dyda[jsig]+0.5*a[j]*(const1/tau*(yji-yjip1)-1./sqpi/tau*(exp1-exp2));
    dyda[ju]=1;
  }
}

