/*! \file spektrumsimulierenimpl.cpp
    \brief Die Implementation der Klasse \ref SpektrumSimulierenImpl

    Diese Datei wurde EINMAL automatisch durch Aufruf von
 
    uic -o spektrumsimulierenimpl.cpp -subimpl SpektrumSimulierenImpl spektrumsimulierenimpl.h spektrumsimulieren.ui 
    
    erzeugt.
    
    Anschlieend wurden die Ereignissbehandlungsroutinen mit dem bentigten Code
    gefllt.
*/
#include "spektrumsimulierenimpl.h"
#include "funcs.h"
#include "nrutil.h"
#include "generators_b.c"
#include <math.h>

extern int overflow;
extern int ndata,jmax;
extern double sigma,delta,t0,gen;

/*
 *  Constructs a SpektrumSimulierenImpl which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 

 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
SpektrumSimulierenImpl::SpektrumSimulierenImpl( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : SpektrumSimulieren( parent, name, modal, fl )
{
   int i;
   QString dummy;
   for (i=1;i<=5;i++) {
     dummy.sprintf("%d",i);
     Startwerte_AnzahlderModelltermeComboBox->insertItem(dummy);
   }
   Startwerte_AnzahlderModelltermeComboBox->setCurrentItem(2);
    Startwerte_Table->setTopMargin(0);
    Startwerte_Table->setLeftMargin(115);
    Startwerte_Table->setColumnMovingEnabled(0);
    Startwerte_Table->setRowMovingEnabled(0);
    Startwerte_Table->setColumnStretchable (0,true);

  AnzahlderModellterme_slot(2);
}

/*  
 *  Destroys the object and frees any allocated resources
 */
SpektrumSimulierenImpl::~SpektrumSimulierenImpl()
{
    // no need to delete child widgets, Qt does it all for us
}

/* 
 * public slot
 */
void SpektrumSimulierenImpl::AnzahlderModellterme_slot(int nr)
{
    QString headerlabel;
    int i;
    jmax=nr+1;
    Startwerte_Table->setNumRows(1);
    QHeader* vertheader=Startwerte_Table->verticalHeader();
    QHeader* horizheader=Startwerte_Table->horizontalHeader();
    Startwerte_Table->setNumRows(2*jmax+1);
    Startwerte_Table->setNumCols(1);
    Startwerte_Table->setColumnStretchable(0,true);
    Startwerte_Table->setText(0,0,"");
    Startwerte_Table->setText(1,0,"");
    vertheader->setMinimumWidth(115);
    horizheader->hide();
    vertheader->setLabel(2*jmax,"Untergrund");
    for (i=0;i<jmax;i++) {
      headerlabel="";
      headerlabel.sprintf("%d. Intensitt * 10^-6",i+1);
      vertheader->setLabel(i,headerlabel);
    }
    for (i=0;i<jmax;i++) {
      headerlabel="";
      headerlabel.sprintf("%d. Lebensd. (ns)",i+1);
      vertheader->setLabel(jmax+i,headerlabel);
    }
}
/* 
 * public slot
 */
void SpektrumSimulierenImpl::OK_slot()
{
  int ma=2*jmax+2;
  ndata=600;
  int eingaberichtig=1;
  int i,j;
  sigma=0.176;
  delta=0.045;
  overflow=0;
  t0=1.26;
  gen=pow(10,-8);
  double erwart,sd,z;
  long idum;
  QFile file;
  double *a,*x,*y,*dyda,ywert,arg,f,fd,korr;
  QString msg,dateiname,dummy;
  dummy=SpektrumNameLineEdit->text();
  if (dummy!="") {
    x=dvector(1,ndata);
    y=dvector(1,ndata);
    a=dvector(1,ma);
    dyda=dvector(1,ma);
     for (i=1;i<=jmax;i++) {
       if (!Startwerte_Table->text(i-1,0).toDouble()) eingaberichtig=0;
       if (Startwerte_Table->text(i-1,0).toDouble()<0) eingaberichtig=-1;
       a[i]=Startwerte_Table->text(i-1,0).toDouble()*pow(10,6);
       
     }
    
     for (i=jmax+1;i<=2*jmax;i++) {
       if (!Startwerte_Table->text(i-1,0).toDouble()) eingaberichtig=0;
       if (Startwerte_Table->text(i-1,0).toDouble()<0) eingaberichtig=-1;
       a[i]=Startwerte_Table->text(i-1,0).toDouble();
     }
     if (!Startwerte_Table->text(2*jmax,0).toDouble()) eingaberichtig=0;
     if (Startwerte_Table->text(2*jmax,0).toDouble()<0) eingaberichtig=-1;
     a[2*jmax+1]=Startwerte_Table->text(2*jmax,0).toDouble();
     a[ma]=sigma;
    
     if (eingaberichtig==1) {
      for (i=1;i<=ndata;i++) {
        x[i]=i;
        funcs(x[i],a,&y[i],dyda,ma);
      }
      if (overflow==0) {
        idum=RandomSpinBox->text().toInt();
        for (i=1;i<=ndata;i++) {
          erwart=y[i];
          sd=sqrt(erwart);
	  z=ran2(&idum);
          ywert=0.;
          do {
            arg=ywert/sqrt(2.)/sd;
            f=erfdp1(arg)+1.-2*z;
            fd=exp(-arg*arg)/sqrt(2.)/sd;
            korr=f/fd;
            ywert=ywert-korr;
            y[i]=ceil(erwart+ywert+.5);
          } while (fabs(korr) > fabs(ywert)*gen);
         }
         dummy=SpektrumNameLineEdit->text();
         int flag=1;
         dateiname="daten/"+dummy+".usr";
         msg=dummy+" existiert schon.\n Wollen Sie das Spektrum berschreiben?";
            if (file.exists(dateiname)) {
	      QMessageBox mb("Frage",msg,QMessageBox::Information,QMessageBox::Yes,QMessageBox::No,QMessageBox::Cancel);
              if (mb.exec()==QMessageBox::Yes) flag=1; else flag=0;
            }
          if (flag==1) {
            file.setName(dateiname);
            file.open(IO_WriteOnly);
            QTextStream outstream(&file);
	    outstream <<dummy<< "\n"<<"Dieses Spektrum wurde per Computer simuliert\n"<<delta<<" "<<t0<<" "<<sigma<<"\n600\n";
            for (i=1;i<=60;i++) {
              for (j=1;j<=10;j++) outstream << y[(i-1)*10+j]<<" ";
              outstream <<"\n";
            }
            outstream <<"0\n";
            file.close();
            close();
	  }
      } else {
	msg="Es ist ein Exponenten-Overflow aufgetreten\n Bitte whlen Sie andere Simulationsparameter";
	QMessageBox::information(0,"Fehler",msg,QMessageBox::Ok);     
    }
    } else if (eingaberichtig==0) {
       msg="Fehlerhafte Eingabe der Startwerte\n Konnte Eingabe nicht zu Zahl konvertieren";
      QMessageBox::information(0,"Fehler",msg,QMessageBox::Ok);
    } else {
      msg="Simulationsparameter drfen nicht negativ sein.";
      QMessageBox::information(0,"Fehler",msg,QMessageBox::Ok);
    }
    free_dvector(dyda,1,ma);
    free_dvector(x,1,ndata);
    free_dvector(y,1,ndata);
    free_dvector(a,1,ma);
  } else {
    msg="Sie mssen einen Namen fr das Spektrum angeben";
    QMessageBox::information(0,"Fehler",msg,QMessageBox::Ok);
  }
}

