/*! \file spektrumsimulierenimpl.h
    \brief Die Definition der Klasse \ref SpektrumSimulierenImpl

    Diese Datei wurde EINMAL automatisch durch Aufruf von

    uic -o spektrumsimulierenimpl.h -subdecl SpektrumSimulierenImpl spektrumsimulieren.h spektrumsimulieren.ui

    erzeugt.
    
    Anschlieend wurden die Ereignissbehandlungsroutinen mit dem bentigten Code
    gefllt.
*/
#ifndef SPEKTRUMSIMULIERENIMPL_H
#define SPEKTRUMSIMULIERENIMPL_H
#include "spektrumsimulieren.h"
#include <qtable.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qtextstream.h>
#include <qfile.h>
#include <qdir.h>
/*! \class SpektrumSimulierenImpl
    \brief Die Klasse des "Spektrum Simulieren - Dialogs"
    
    Die Klasse des "Spektrum Simulieren - Dialogs" ist abgeleitet von der von uic (User Interface Compiler)
    automatisch erzeugten Klasse SpektrumSimulieren, welche in der Datei spektrumsimulieren.h definiert wird.
*/
class SpektrumSimulierenImpl : public SpektrumSimulieren
{ 
    Q_OBJECT

public:
    /*! \fn SpektrumSimulierenImpl( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
        \brief Der Standardkonstruktor des "SpektrumSimulieren - Diallogs" 

         \param parent Die Parent-Klasse vom Typ QWidget
         \param name Der Name
         \param fl Hier knnten noch einige flags angegeben werden
    */
    SpektrumSimulierenImpl( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    /*! \fn ~PositronImp();
        \brief Der Destruktor des "SpektrumSimulieren - Dialogs"

        Hier wird Speicher wieder freigegeben
    */
    ~SpektrumSimulierenImpl();

public slots:
    /*! \fn void AnzahlderModellterme_slot(int nr);
        \brief Die Ereignissbehandlunsroutine der Combobox, aus der der Benutzer die Anzahl
        der Modellterme auswhlen kann.

        \param nr Die Nummer des Eintrags, den er aus der Combobox ausgewhlt hat.

        Dieser Slot wird aufgerufen, wenn der Benutzer die Anzahl der Modellterme verndert.
       
        Dadurch wird die Startwerttabelle gelscht, und der Benutzer kann neue Startwerte
        eintragen.
    */
    void AnzahlderModellterme_slot(int nr);
    /*! \fn void OK_slot();
        \brief Die Ereignissbehandlungsroutine des OK - Buttons

        Dieser Slot wird aufgerufen, wenn der Benutzer auf den OK-Button drckt.
        
        Dadurch wird die Simulation eines neuen Positronenlebensdauerspektrums gestartet. 
    */
    void OK_slot();
};

#endif // SPEKTRUMSIMULIERENIMPL_H
